var pages = {}; //объекты страниц
var buttons = new Buttons();
var animated = false; //признак активной анимации
var player;
var onKeyBack = onKeyGreen = onKeyRed = onKeyYellow = onKeyUp = onKeyRight = onKeyDown = onKeyLeft = onAnyKey = null;
var urlParams = {};
var widgetAPI = new Common.API.Widget();
var tvKey = new Common.API.TVKeyValue();
var plugin = new Common.API.Plugin();
var VER = "";

function generateSerialNumber() {
    var t = new Date();
    var ms = t.getTime();
  	var serialNumber = MD5(ms + 'Samsung' + Math.floor(Math.random()*1000000));
    sf.core.localData('serialNumber', serialNumber);
    return serialNumber;
}

var Main = 
{
}

Main.onShowEvent = function() {
	var PL_NNAVI_STATE_BANNER_NONE = 0;
	var PL_NNAVI_STATE_BANNER_VOL = 1;
	var PL_NNAVI_STATE_BANNER_VOL_CH = 2;
	var pluginAPI = new Common.API.Plugin();
	var NNaviPlugin = document.getElementById("pluginObjectNNavi");
	var tvKey = new Common.API.TVKeyValue();
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	pluginAPI.unregistKey(tvKey.KEY_MUTE);
	NNaviPlugin.SetBannerState(PL_NNAVI_STATE_BANNER_VOL);
}

Main.onLoad = function()
{
	window.onShow = Main.onShowEvent;
	try {
	   var firmware = document.getElementById("pluginObjectNNavi").GetFirmware();
	   alert('Firmware: '+firmware);
	   if (firmware < 'T-INFOLINK2012-1004') {
	        throw 'Firmware version is too low';
       }
	   VER = '2011'; // to disable animation
	} catch(e) {
		alert("Old model of TV set");
		VER = '2011';
	}
	alert("VER=" + VER);
	var MAC = document.getElementById("pluginNetwork").GetMAC();
	alert('MAC='+MAC);
	Data.serial = document.getElementById("pluginObjectNNavi").GetDUID(MAC);
	alert('Serial='+Data.serial);
		
	pages['index'] = new PageIndex();
	pages['projects'] = new PageProjects();
	pages['project'] = new PageProject();
	pages['search'] = new PageSearch();
	pages['profile'] = new PageProfile();
	
	player = new Player();
	
	buttons.set(1, 'm1', [null,2,null,null], function() {showPage('index')});
	buttons.set(2, 'm2', [null,3,null,1], function() {showPage('projects', 2)});
	buttons.set(3, 'm3', [null,4,null,2], function() {showPage('projects', 1)});
	buttons.set(4, 'm4', [null,6,null,3], function() {showPage('projects', 3)});
	buttons.set(5, 'm5', [null,null,null,null]);
	buttons.set(6, 'm6', [null,7,null,4], function() {showPage('profile')});
	buttons.set(7, 'm7', [null,8,null,6], function() {showPage('search')});
	buttons.splice(8,1,null);

    buttons[1].el.onmouseover();
	buttons[1].el.onclick();
	document.getElementById('player_big').style.top = '540px';
	// To enable the key event processing
	document.getElementById("anchor").focus();
	// Set Default key handler function
	widgetAPI.sendReadyEvent();
}

Main.onUnload = function()
{
	if (player.state > 0) player.el_player.Stop();
}

Main.MainKeyHandler = function()
{
	var KeyCode = event.keyCode;
    if (onAnyKey) {
		if (! onAnyKey(KeyCode)) return;
		//event.preventDefault();
	}
	switch(KeyCode)
	{
		case tvKey.KEY_EXIT :
			alert('Goodbye');
			widgetAPI.sendExitEvent();
			break;
		case tvKey.KEY_LEFT :
			if (onKeyLeft) onKeyLeft();
			else if (buttons.hover_btn.left) buttons[buttons.hover_btn.left].el.onmouseover();
			event.preventDefault();
			break;
		case tvKey.KEY_RIGHT :
			if (onKeyRight) onKeyRight();
			else if (buttons.hover_btn.right) buttons[buttons.hover_btn.right].el.onmouseover();
			event.preventDefault();
			break;
		case tvKey.KEY_UP :
			if (onKeyUp) onKeyUp();
			else if (buttons.hover_btn.up) buttons[buttons.hover_btn.up].el.onmouseover();
			event.preventDefault();
			break;
		case tvKey.KEY_DOWN :
			if (onKeyDown) onKeyDown();
			else if (buttons.hover_btn.down) buttons[buttons.hover_btn.down].el.onmouseover();
			event.preventDefault();
			break;
		case tvKey.KEY_ENTER :
			if (buttons.hover_btn != buttons.act_btn) buttons.hover_btn.el.onclick();
			event.preventDefault();
			break;
		case tvKey.KEY_GREEN :
			if (onKeyGreen) {
				onKeyGreen();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_RED :
			if (onKeyRed) {
				onKeyRed();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_YELLOW :
			if (onKeyYellow) {
				onKeyYellow();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_PLAY :
			if (onKeyPlay) {
				onKeyPlay();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_PAUSE :
			if (onKeyPause) {
				onKeyPause();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_STOP :
			if (onKeyStop) {
				onKeyStop();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_RW :
		case tvKey.KEY_REWIND_ :
			if (onKeyRewind) {
				onKeyRewind();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_FF :
		case tvKey.KEY_FF_ :
		    if (onKeyFForward) {
				onKeyFForward();
				event.preventDefault();
			}
			break;
		case tvKey.KEY_RETURN :
			if (onKeyBack) {
				onKeyBack();
				event.preventDefault();
			} else {
				event.preventDefault();
				widgetAPI.sendReturnEvent();
			}
			break;
		default :
			break;
	}
}

function showPage(page_name, param) {
	for(var i in pages) {
		pages[i].hide();
	}
	animated = false;
	document.getElementById('content').className = 'content page-' + page_name + ' page-' + page_name+(param ? param : '');
	pages[page_name].show(param);
	//document.getElementById('anchor').focus();
	if (window.yaCounter18298522) {
        var s = page_name;
        var p = param ? param : '';
        if (s == 'projects')
			switch (p) {
                case 1:
                  p = 'Шоу';
                  break;
                case 2:
                  p = 'Сериалы';
                  break;
                case 3:
                  p = 'Программы';
                  break;
            };
         if (s == 'project' && Data.projects[p])
              p = Data.projects[p].title;
         window.yaCounter18298522.hit(page_name + '/' + (param ? param : ''), s + '/' + p);
    }
}

function showCurrPage() {
	animated = false;
	if (buttons.act_btn) {
		for(var i=1; i < 8; i++) {
			if (buttons[i] && hasClass(buttons[i].el, 'act')) {
				buttons[i].el.onmouseover();
				buttons[i].onclick(buttons[i]);
				break;
			}
		}
	} else {
		//костыль для возврата к поиску
		buttons[7].el.onmouseover();
		buttons[7].el.onclick();
	}
}

function hoverCurrPage() {
	for(var i=1; i < 8; i++) {
		if (buttons[i] && hasClass(buttons[i].el, 'act')) {
			buttons[i].el.onmouseover();
			break;
		}
	}
}

function showConnectionFailure() {
    var popup = document.getElementById('connection_failure');
	show(popup);
	setTimeout(function() {
			hide(popup);
	}, 4000);
}
