var PageProjects = function() {
	//dom элементы
	this.el_content = document.getElementById('page_projects');
	this.el_banner1 = document.getElementById('page_projects_banner_1');
	this.el_banner2 = document.getElementById('page_projects_banner_2');
	this.el_projects = document.getElementById('page_projects_projects');
	this.el_btn_up = document.getElementById('page_projects_btn_up');
	this.el_btn_down = document.getElementById('page_projects_btn_down');
	this.el_scroll = document.getElementById('page_projects_scroll');
	this.el_scroll_control = document.getElementById('page_projects_scroll_control');
	
	this.category = null;
	this.banners = [];
	this.project_index = 0;
	this.projects = [];
	this.loading = false;
};

PageProjects.prototype.show = function(category) {
	if (category != null) this.category = category;
	show('main_preloader');
	show(this.el_content);
	
	widgetAPI.putInnerHTML(this.el_banner1, '');
	widgetAPI.putInnerHTML(this.el_banner2, '');
	widgetAPI.putInnerHTML(this.el_projects, '');
	
	this.loading = 2;
	var _this = this;
	Data.getBanners(function(banners) {
		_this.banners = banners;
		_this.loading--;
		if (!_this.loading) _this.showAfterload();
	});
	Data.getProjects(this.category, function(projects) {
		_this.projects = projects;
		_this.loading--;
		if (!_this.loading) _this.showAfterload();
	});
	
        onKeyBack = function() {buttons[1].el.onmouseover(); buttons[1].el.onclick()};
};

PageProjects.prototype.showAfterload = function() {
	buttons.clear(10);
	buttons[1].down = buttons[2].down = buttons[3].down = buttons[4].down = buttons[5].down = buttons[6].down = buttons[7].down = null;

	var _this = this;
	function fn_project_click(btn) {
		var delta = btn.k - 14;
		showPage('project', _this.projects[_this.project_index+delta].id);
	};
	function fn_btn_click(delta) {
		if (animated) return;
		if (_this.project_index == 0 && delta == -1) return;
		if (_this.project_index+9 >= _this.projects.length && delta == 1) return;
		
		buttons.clear(14);
		_this.project_index += 3*delta;
		_this.renderProjects();
		_this.setProjectsBtns(fn_project_click);
		
		animateY(_this.el_projects, -Math.floor(_this.project_index/3)*SIZES.projects.height);
		var y = Math.round(Math.ceil(_this.project_index/3) * SIZES.projects.scroll_height / Math.ceil((_this.projects.length-9)/3));
		if (y < 0) y = 0;
		animateY(_this.el_scroll, y);
	};
	
	buttons.set(12, this.el_btn_up, [7,null,13,null, true], function(){ fn_btn_click(-1); });
	buttons.set(13, this.el_btn_down, [12,null,null,null, true], function(){ fn_btn_click(1); });
	
	this.el_scroll_control.style.visibility = this.projects.length < 10 ? 'hidden' : 'visible';

	this.showBanners();
	this.showProjects(fn_project_click);
	
	hide('main_preloader');
	animated = false;
};

PageProjects.prototype.showProjects = function(click_callback) {
	this.project_index = 0;
	animateInitY(this.el_projects, 0, 0.5);
	animateInitY(this.el_scroll, 0, 0.5);

	this.renderProjects();
	this.setProjectsBtns(click_callback);
};

PageProjects.prototype.renderProjects = function() {
	var html = '';
	var from = (this.project_index - 3 >= 0) ? this.project_index - 3 : 0;
	var to = (this.project_index + 11 < this.projects.length) ? this.project_index + 11 : this.projects.length - 1;
	for (var i=from; i <= to; i++) {
		html += '<div class="project-min" id="page_projects_project_'+i+'"'+((i - from < 3) ? ' style="margin-top: '+Math.floor(from/3)*SIZES.projects.height+'px"' : '')+'>';
		if (this.projects[i].favorited) html += '<div class="tab"></div>';
		html += '<div class="p-mini-bord"></div>';
		if (this.projects[i].recent) html += '<div class="bul"><div class="bul-l"></div><div class="bul-c">'+this.projects[i].recent+'</div><div class="bul-r"></div><div class="clear"></div></div>';
		if (this.projects[i].seen_count > 0 && this.projects[i].overall_count > 0) html += '<div class="pun" style="background-position:-'+Math.round(SIZES.projects.img_width-this.projects[i].seen_count*SIZES.projects.img_width/this.projects[i].overall_count)+'px 0px;">' + (this.projects[i].seen_count / this.projects[i].overall_count * 100 < 50 ? '<center style="color: white" >' : '<center>' )+this.projects[i].seen_count+'/'+this.projects[i].overall_count+'</center></div>';
		html += '<img src="'+this.projects[i].small_thumbnail+'" width="'+SIZES.projects.img_width+'" height="'+SIZES.projects.img_height+'"><br>'+this.projects[i].title+'</div>';
	}
	this.el_projects.style.height = Math.ceil(this.projects.length/3)*207;
	widgetAPI.putInnerHTML(this.el_projects, html);
	//this.el_projects.innerHTML = html;
};

PageProjects.prototype.setProjectsBtns = function(click_callback) {
	var els = [];
	for (var i=this.project_index; i < this.projects.length && i < this.project_index+9; i++) {
		els.push('page_projects_project_'+i);
	}
	
	buttons.setGroup(14, els, '3x3', true, click_callback);
	
	if (buttons[14]) {
		buttons[14].up=2;
		buttons[1].down = buttons[2].down = buttons[3].down = buttons[4].down = buttons[5].down = buttons[6].down = buttons[7].down = 14;
	}
	if (buttons[15]) {
		buttons[15].up=4;
		buttons[4].down = buttons[5].down = buttons[6].down = buttons[7].down = 15;
	}
	if (buttons[16]) {
		buttons[16].up=4;
		buttons[5].down = buttons[6].down = buttons[7].down = 16;
	}
	
	if (buttons[16]) {
		buttons[16].right = 12;
		buttons[12].left = 16;
	} else if (buttons[15]) {
		buttons[15].right = 12;
		buttons[12].left = 15;
	} else if (buttons[14]) {
		buttons[14].right = 12;
		buttons[12].left = 14;
	}
	if (buttons[19]) {
		buttons[19].right = 12;
	} else if (buttons[18]) {
		buttons[18].right = 12;
	} else if (buttons[17]) {
		buttons[17].right = 12;
	}
	if (buttons[22]) {
		buttons[22].right = 13;
		buttons[13].left = 22;
	} else if (buttons[21]) {
		buttons[21].right = 13;
		buttons[13].left = 21;
	} else if (buttons[20]) {
		buttons[20].right = 13;
		buttons[13].left = 20;
	}
	
	if (this.banners[0] && buttons[14]) {
		buttons[1].down = 10;
		buttons[14].left = 10;
		buttons[10].right = 14;
		if (buttons[17]) buttons[17].left = 10;
		if (buttons[20]) buttons[20].left = 10;
	}
	if (this.banners[1]) {
		if (buttons[14]) buttons[11].right = 14;
		if (buttons[20]) {
			buttons[20].left = 11;
			buttons[11].right = 20;
		}
        }

        var _this = this;
        // для скролла вверх с помощью VK_UP создаём ещё 3 кнопки сверху
        if (this.project_index > 0) {
            var up_els = [];
            for (var i = this.project_index - 3; i < this.project_index; i++)
                up_els.push('page_projects_project_' + i);
            buttons.setGroup(23, up_els, '1x3', true, null, function(data) {
				_this.el_btn_up.onclick();
				buttons.hover_btn = null; // указывает на элемент который был удален при putInnerHTML
                buttons[data.k - 9].el.onmouseover();
            });
            buttons[14].up = 23; buttons[15].up = 24; buttons[16].up = 25;
        }
        // для скролла вниз с помощью VK_DOWN создаём ещё 3 кнопки снизу
        if (this.project_index + 9 < this.projects.length) {
            var down_els = [];
            for (var i = this.project_index + 11; i > this.project_index + 8; i--)
                if (document.getElementById('page_projects_project_' + i)) down_els.push('page_projects_project_' + i);
            buttons.setGroup(26, down_els, '1x3', true, null, function(data) {
                _this.el_btn_down.onclick();
				buttons.hover_btn = null; // указывает на элемент который был удален при putInnerHTML
                buttons[data.k - 6].el.onmouseover();
            });
            buttons[20].down = buttons[21].down = buttons[22].down = 26;
            if (buttons[27]) buttons[21].down = buttons[22].down = 27;
            if (buttons[28]) buttons[22].down = 28;
        }
        // обработка колеса для magic пульта
        this.el_projects.onmousewheel = function(e) {
            //console.log(e.wheelDelta);
            if (e.wheelDelta > 0) { // up
                _this.el_btn_up.onclick();
            }
            else { // down
                _this.el_btn_down.onclick();
            }
        };
	if (this.projects.length < 10) {
	  buttons.disable(12);
	  buttons.disable(13);
	}
};

PageProjects.prototype.showBanners = function() {
	var _this = this;
	buttons.set(10, this.el_banner1, [null,null,null,null, true], function(){
		if (_this.banners[0] && _this.banners[0].project_id) showPage('project',  _this.banners[0].project_id);
	});
	buttons.set(11, this.el_banner2, [null,null,null,null, true], function(){
		if (_this.banners[1] && _this.banners[1].project_id) showPage('project',  _this.banners[1].project_id);
	});
	if (this.banners[0]) {
		widgetAPI.putInnerHTML(this.el_banner1, '<div class="projects-light"></div><img src="'+this.banners[0].medium_picture_url+'" width="'+SIZES.projects.banner_width+'" height="'+SIZES.projects.banner_height+'"><br>'+this.banners[0].title);
		buttons[10].up=1;
		buttons[1].down = 10;
	}
	if (this.banners[1]) {
		widgetAPI.putInnerHTML(this.el_banner2, '<div class="projects-light"></div><img src="'+this.banners[1].medium_picture_url+'" width="'+SIZES.projects.banner_width+'" height="'+SIZES.projects.banner_height+'"><br>'+this.banners[1].title);
		buttons[11].up=10;
		buttons[10].down=11;
	}
};

PageProjects.prototype.hide = function() {
	buttons.clear(10);
	hide(this.el_content);
};
