// buttons[10], buttons[11], buttons[12] считаются уже установленными кнопками плеера, buttons[14] - кнопка фулскрин
Player = function() {
	this.el_track_player = document.getElementById('page_project_track_player');
	this.el_prog = document.getElementById('page_project_btn_prog');
	this.el_time = document.getElementById('page_project_track_time');
	this.el_player = document.getElementById('pluginPlayer');
	this.el_img = document.getElementById('page_project_track_img');
	this.el_line_buf = document.getElementById('page_project_line_buf');
	this.el_line_time= document.getElementById('page_project_line_time');
	this.el_timeprog = document.getElementById('page_project_timeprog');
	this.el_line_prog = document.getElementById('page_project_line_prog');

	this.el_big_player = document.getElementById('player_big');
	this.el_big_play = document.getElementById('player_big_btn_play');
	this.el_big_stop = document.getElementById('player_big_btn_stop');
	this.el_big_prog = document.getElementById('player_big_btn_prog');
	this.el_big_time = document.getElementById('player_big_btn_time');
	this.el_big_sets = document.getElementById('player_big_btn_sets');
	this.el_big_close = document.getElementById('player_big_btn_close');
	this.el_big_line_buf = document.getElementById('player_big_line_buf');
	this.el_big_line_time = document.getElementById('player_big_line_time');
	this.el_big_timeprog = document.getElementById('player_big_timeprog');
	this.el_big_line_prog = document.getElementById('player_big_line_prog');
	
	this.el_loading = document.getElementById('player_loader');
	this.el_error = document.getElementById('player_error');

	this.timer = null;
	this.state = 0;		//состояния: 0 - стоп, 1 - плей, 2 - пауза
	this.fullscreen = false;
	this.fullscreen_panel_hide = false;
	this.fullscreen_timer = null;
	this.fullscreen_counter = 0;
	this.duration = 0;
	this.buffering = false;
	this.timeCurrent = 0;
	this.active_button = null;

	this.el_player.OnCurrentPlayTime = 'Player.prototype.onCurrentPlayTime';
	this.el_player.OnStreamInfoReady = 'Player.prototype.onStreamInfoReady';
	this.el_player.OnBufferingProgress = 'Player.prototype.onBufferingProgress';
	this.el_player.OnBufferingStart = 'Player.prototype.onBufferingStart';
	this.el_player.OnBufferingComplete = 'Player.prototype.onBufferingComplete';
	this.el_player.OnConnectionFailed = 'Player.prototype.onConnectionFailed';
	this.el_player.OnRenderError = 'Player.prototype.onRenderError';
	this.el_player.OnNetworkDisconnected = 'Player.prototype.onNetworkDisconnected';
	this.el_player.OnStreamNotFound = 'Player.prototype.onStreamNotFound';
	this.el_player.OnServerError = 'Player.prototype.onServerError';
};

Player.prototype.init = function(track, end_callback) {
	this.track = track;
	this.end_callback = end_callback;
	if (this.timer) {
		clearInterval(this.timer);
		this.timer = null;
	}
	this.state = 0;
	hide(this.el_loading);
	hide(this.el_error);
	this.setWindow();
	this.initButtons();
};

Player.prototype.initButtons = function() {
	var _this = this;

	function fn_act(cl) {
		removeClass(_this.el_track_player, ['act-play', 'act-stop']);
		removeClass(_this.el_big_player.children[0], ['act-play', 'act-stop', 'act-sets', 'act-close']);
		
		addClass(_this.el_track_player, cl);
		addClass(_this.el_big_player.children[0], cl);
		setTimeout(function() {	
			removeClass(_this.el_track_player, cl);
			removeClass(_this.el_big_player.children[0], cl);
		}, 300);
	}
	
	//кнопки в фулскрине
	var els = [this.el_big_play, this.el_big_stop, this.el_big_prog, this.el_big_sets, this.el_big_close];
	buttons.setGroup(30, els, '1x5', true); //TODO

	//плей/пауза
	buttons[30].onclick = buttons[10].onclick = function() {
		fn_act('act-play');
		if (_this.state == 0) _this.play();
		else if (_this.state == 1) _this.pause();
		else if (_this.state == 2) _this.resume();
	};
	//стоп
	buttons[31].onclick = buttons[11].onclick = function() {
		fn_act('act-stop');
		_this.stop();
		if (_this.fullscreen) _this.setWindow();
	};
	//hover для кнопок
	buttons[10].onhover = buttons[11].onhover = function(btn) {
		removeClass(_this.el_track_player, ['hover-play', 'hover-stop', 'hover-prog']);
		if (btn.k == 10) addClass(_this.el_track_player, 'hover-play');
		if (btn.k == 11) addClass(_this.el_track_player, 'hover-stop');
	};
	buttons[10].onunhover = buttons[11].onunhover = function(btn) {
		removeClass(_this.el_track_player, ['hover-play', 'hover-stop']);
	};
	buttons[30].onhover = buttons[31].onhover = buttons[34].onhover = function(btn) {
		removeClass(_this.el_big_player.children[0], ['hover-play', 'hover-stop', 'hover-prog', 'hover-sets', 'hover-close']);
		if (btn.k == 30) addClass(_this.el_big_player.children[0], 'hover-play');
		if (btn.k == 31) addClass(_this.el_big_player.children[0], 'hover-stop');
		if (btn.k == 33) addClass(_this.el_big_player.children[0], 'hover-sets');
		if (btn.k == 34) addClass(_this.el_big_player.children[0], 'hover-close');
	};
	buttons[30].onunhover = buttons[31].onunhover = buttons[34].onunhover = function(btn) {
		removeClass(_this.el_big_player.children[0], ['hover-play', 'hover-stop', 'hover-prog', 'hover-sets', 'hover-close']);
	};
	
	//скрыть настройки
	buttons.disable(32); buttons[32].el.style.opacity = 1;
	buttons.disable(33); buttons[33].el.style.opacity = 1;

	//выход из фулскрина
	buttons[34].onclick = function() {
		_this.setWindow();
	};

};

Player.prototype.setWindow = function() {
    this.el_player.SetDisplayArea(32, 87, 296, 164);
	show("head_menu");
    show("page_project");
	this.el_loading.style.left = '159px';
	this.el_loading.style.top = '142px';
	this.el_loading.style.width = '54px';
	this.el_loading.style.height = '9px';
	this.el_error.style.left = '24px';
	this.el_error.style.top = '157px';
	this.el_error.style.width = '308px';

	hide(this.el_big_player);
	show(this.el_track_player);
	if (this.fullscreen) {
		this.fullscreen = false;
		clearInterval(this.fullscreen_timer);
		this.el_player.onmousemove = onAnyKey = null;
		onKeyBack = showCurrPage;
		buttons[this.active_button].el.onmouseover();
		if (this.state == 2) this.el_player.Pause();
	}
};

Player.prototype.setFullscreen = function() {
	this.active_button = buttons.hover_btn.k; // сохраним текущую позицию фокуса для восстановления после возвращения из фулскрина
    hide("head_menu");
    hide("page_project");
    this.el_player.SetDisplayArea(0, 0, 960, 540);
	this.el_loading.style.left = '451px';
	this.el_loading.style.top = '225px';
	this.el_loading.style.width = '108px';
	this.el_loading.style.height = '18px';
	this.el_error.style.left = '0px';
	this.el_error.style.top = '225px';
	this.el_error.style.width = '960px';
	
	hide(this.el_track_player);
	buttons[30].el.onmouseover();
	var _this = this;
	animateInitY(this.el_big_player, 0, 0.5);
	show(this.el_big_player);
	if (this.state == 2) this.el_player.Pause();
	setTimeout(function() { _this.showFullscreenPanel(); }, 100);
	
	this.fullscreen = true;
	this.fullscreen_panel_hide = false;
	this.fullscreen_counter = 0;
	this.fullscreen_timer = setInterval(function() {
		if (_this.fullscreen_counter++ > 2 && !_this.fullscreen_panel_hide) {
			animateY(_this.el_big_player, 65);
			_this.fullscreen_panel_hide = true;
			_this.fullscreen_counter = 0;
		}
	}, 1000);
	this.el_player.onmousemove = onAnyKey = function(k) {
		_this.fullscreen_counter = 0;
		if (_this.fullscreen_panel_hide) {
			_this.showFullscreenPanel();
			return true; // по требованию местного офиса samsung
		} else {
			return true;
		}
	}
	onKeyBack = function() {buttons[34].el.onclick()};
};

Player.prototype.showFullscreenPanel = function() {
	animateY(this.el_big_player, -65);
	this.fullscreen_panel_hide = false;
};

Player.prototype.play = function() {
    if (this.buffering) return;
	if (this.state != 1) {
		this.state = 1;
		this.showStatus(0);
		hide(this.el_img);
		hide(this.el_error);
		addClass(this.el_track_player, 'pause');
		addClass(this.el_big_player.children[0], 'pause');
		alert('Start playing: '+ this.track.title);
		plugin.setOffScreenSaver();
		show(this.el_loading);
		this.buffering = true;
		Data.first_send_stat = false;
		this.el_player.Play(this.track.tv);
        var rep = "/project/" + Data.projects[this.track.project_id].title + "/" + this.track.title;
//        _gaq.push(['_trackPageview', rep]);
        yaCounter18298522.hit(rep, rep);
	}
};

Player.prototype.pause = function() {
	if (this.buffering) return;
	this.state = 2;
	removeClass(this.el_track_player, 'pause');
	removeClass(this.el_big_player.children[0], 'pause');
	plugin.setOnScreenSaver();
	this.el_player.Pause();
};

Player.prototype.stop = function() {
    if (this.buffering) return;
	if (this.state != 0) {
		this.state = 0;
		removeClass(this.el_track_player, 'pause');
		removeClass(this.el_big_player.children[0], 'pause');
		plugin.setOnScreenSaver();
		this.el_player.Stop();
		this.showStatus(0);
	}
};

Player.prototype.resume = function() {
    if (this.buffering) return;
	this.state = 1;
	addClass(this.el_track_player, 'pause');
	addClass(this.el_big_player.children[0], 'pause');
	plugin.setOffScreenSaver();
	this.el_player.Resume();
};

Player.prototype.seek = function(val) {
    if (this.buffering) return;
	if (val > 0) {
		this.el_player.JumpForward(val);
	}
	else {
		var to_go = this.timeCurrent/1000 < -val ? this.timeCurrent/1000 : -val;
		this.el_player.JumpBackward(to_go);
	}
};

Player.prototype.onCurrentPlayTime = function(time) {
	this.buffering = false;
	if (player.state == 1 && time == 4294966) return;
	if (time == 0 && this.timeCurrent != time) this.currentMinute = 0;
	if (player.state != 0 && time >= (player.track.duration-1) * 1000) {
		alert("onCurrentPlayTime: player.state=" + player.state + ", time=" + time + ",  player.track.duration=" + player.track.duration*1000);
		alert("onCurrentPlayTime: player.track=" + player.track.title);
		alert("onCurrentPlayTime: player.stop()");
		player.stop();
		if (this.stopCallback) this.stopCallback();
	} else {
		if (player.state != 0 && this.playCallback) this.playCallback(time, player.track.duration);
		var st = (time / 1000) % 60;
		if (st == 0 && this.timeCurrent != time) {
			Data.sendStat(player.track.id, this.currentMinute);
			this.currentMinute++;
		}
		player.timeCurrent = time;
	}
};

Player.prototype.onBufferingProgress = function(val) {
	this.buffering = true;
	player.buffering = true;
	if (player.state != 0 && this.buffCallback) this.buffCallback(val);
};

Player.prototype.onBufferingStart = function() {
	this.buffering = true;
	player.buffering = true;
	if (player.state != 0 && this.buffCallback) this.buffCallback(0);
};

Player.prototype.onBufferingComplete = function() {
	this.buffering = false;
	player.buffering = false;
	if (player.state != 0 && this.buffCallback) this.buffCallback(100);
};

Player.prototype.onConnectionFailed = function() {
	alert("Connection Failed");
	if (player.state != 0 && player.errorCallback) {
		player.stop();
		player.errorCallback();
	}
};

Player.prototype.onNetworkDisconnected = function() {
	alert("Network Disconnected");
	if (player.state != 0 && player.errorCallback) {
		player.stop();
		player.errorCallback();
	}
};

Player.prototype.onRenderError = function() {
	alert("Render Error");
	if (player.state != 0 && player.errorCallback) {
		player.stop();
		player.errorCallback();
	}
};

Player.prototype.onStreamNotFound = function() {
	alert("Stream Not Found");
	if (player.state != 0 && player.errorCallback) {
		player.stop();
		player.errorCallback();
	}
};

Player.prototype.onServerError = function() {
	alert("Server Error");
	if (player.state != 0 && player.errorCallback) {
		player.stop();
		player.errorCallback();
	}
};

Player.prototype.onStreamInfoReady = function() {
	this.duration = player.el_player.GetDuration();
};


Player.prototype.playCallback = function(time, duration) {
	this.showStatus(time);
};

Player.prototype.buffCallback = function(val) {
	if (val == 0) {
		show(player.el_loading);
	} else if (val == 100) {
		hide(player.el_loading);
	}
};

Player.prototype.stopCallback = function() {
	if (player.end_callback) player.end_callback();
};

Player.prototype.errorCallback = function() {
	var _this = player;
	hide(_this.el_loading);
	widgetAPI.putInnerHTML(_this.el_error, "Сетевая ошибка");
	show(_this.el_error);
};

Player.prototype.showStatus = function(time) {
	var _this = player;
	widgetAPI.putInnerHTML(_this.el_time, formatTime(Math.round(time/1000))+' / '+formatTime(_this.track.duration));
	widgetAPI.putInnerHTML(_this.el_big_time, formatTime(Math.round(time/1000))+' / '+formatTime(_this.track.duration));
	_this.el_line_prog.style.width = Math.round(time * 126 / _this.track.duration / 1000) + 11 + 'px';
	_this.el_big_line_prog.style.width = Math.round(time * 478 / _this.track.duration / 1000) + 14 + 'px';
};
